# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#
#    Copyright (c) 2018 Grupo SACSA - http://www.gruposacsa.com.mx
#    All Rights Reserved.
############################################################################
#    Coded by:
#       Jorge Alfonso Medina Uriarte (desarrollo.sacsa@gruposacsa.com.mx)
############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp import models, fields, api
from datetime import datetime

class res_partner(models.Model):
    _inherit = 'res.partner'

    partner_mod_ids = fields.One2many('res.partner.mod.ref',
                                      'partner_id',
                                      'Bank Reference',
                                       )

    @api.multi
    def refresh_reference(self):
        self.env['res.partner.mod.ref'].search([('partner_id', '=', self.id)]).unlink()
        mods_ids = []
        for line in self.env['res.partner.mod'].search([]):
            ref = self.env['res.partner.mod.ref'].get_transfer_ref(line.name, line.mod_sucursal, line.mod_cuenta, self.id, line.mod_empresa)
            rs = {'company_id': line.company_id,
                  'name': line.name,
                  'mod_empresa': line.mod_empresa,
                  'mod_sucursal': line.mod_sucursal,
                  'mod_cuenta': line.mod_cuenta,
                  'de_clabe': line.de_clabe,
                  'partner_id': self.id,
                  'reference' : ref
                  }
            mods_ids.append(rs)
        self.partner_mod_ids = mods_ids
        return