# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (c) 2016 DME Soluciones - http://www.dmesoluciones.com
#    All Rights Reserved.
############################################################################
#    Coded by: Jorge Alfonso Medina Uriarte(jorge.medina@dmesoluciones.com)
############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from openerp import fields as f
from openerp import models

class res_partner_mod(osv.Model):
    _name= "res.partner.mod"

    _columns = {
        'name': fields.char('Bank'),
        'company_id': fields.many2one('res.company', 'Company'),
        'mod_empresa': fields.char('Enterprise Mod'),
        'mod_sucursal': fields.char('Branch Mod'),
        'mod_cuenta': fields.char('Account Mod'),
        'de_clabe': fields.char('CLABE'),
    }


class res_partner_mod_ref(models.Model):
    _name= "res.partner.mod.ref"

    _columns = {
        'name': fields.char('Bank'),
        'company_id': fields.many2one('res.company', 'Company'),
        'mod_empresa': fields.char('Enterprise Mod'),
        'mod_sucursal': fields.char('Branch Mod'),
        'mod_cuenta': fields.char('Account Mod'),
        'de_clabe': fields.char('CLABE'),
        'reference': fields.char('Reference'),
    }
    partner_id = f.Many2one(
        'res.partner', 'Partner',
    )

    def get_transfer_ref(self, cr, uid, name, mod_suc, mod_cta, partner_id, mod_empresa):
        context = {}
        ref = name
        #partner_obj = self.env['res.partner']
        #partner = partner_obj.browse(partner_id)
        partner_obj = self.pool.get('res.partner')
        partner = partner_obj.browse(cr, uid, partner_id, context)

        if name == 'Banamex':
            ref = self._get_ref_BNMX(cr, uid, mod_suc, mod_cta, partner_id)
            ref = partner.vat_split + ref
        elif name == 'Banorte':
            ref = self._get_ref_Banorte(mod_empresa, partner_id)
        elif name == 'Bancoppel':
            ref = partner.name
        else:
            ref = 'No definido'
        return ref

    def _get_ref_BNMX(self, cr, uid, mod_suc, mod_cta, partner_id):
        ref = ''
        cero = '0'
        context = {}
        partner_obj = self.pool.get('res.partner')
        partner = partner_obj.browse(cr, uid, partner_id, context)
        #partner_obj = self.env['res.partner']
        #partner = partner_obj.browse(partner_id)
        vat_split = conv_ascii(partner.vat_split)
        sCliente = cero * (18 - len(str(vat_split))) + str(vat_split)
        sSucursal = cero * (4 - len(str(mod_suc))) + str(mod_suc)
        sCta = cero * (7 - len(str(mod_cta))) + str(mod_cta)
        sCadenaTmp = sSucursal + sCta + sCliente

        sCadena = []
        for c in sCadenaTmp: sCadena.append(c)
        iCount = 1
        nSuma = 0
        nValue = 0
        sChar = ''
        while (iCount <= 29):
            nValue = 0
            sChar = sCadena[iCount - 1]
            sChar = sChar.upper()

            if ord(sChar) >= 48 and ord(sChar) <= 57:
                nValue = int(sChar)
            if ord(sChar) >= 65 and ord(sChar) <= 90:
                nValue = self._get_Letter_Value_MOD97(sChar)

            context = {}
            mod97_obj = self.pool.get('mod97')
            mod97_id = mod97_obj.search(cr, uid, [('name', '=', 'MOD97_POS' + str(iCount))])
            mod97 = mod97_obj.browse(cr, uid, mod97_id, context)
            nValPos = int(mod97[0].value)
            nSuma = nSuma + (nValue * nValPos)

            iCount = iCount + 1
        nSuma = nSuma % 97
        nSuma = 99 - nSuma
        # ref = str(partner.vat_split) + cero * (2 - len(str(nSuma))) + str(nSuma)
        ref = cero * (2 - len(str(nSuma))) + str(nSuma)
        return ref

    def _get_Letter_Value_MOD97(self, letter):
        nValor = 0
        if letter in ('A','B','C'):
            nValor = 2
        elif letter in ('D','E','F'):
            nValor = 3
        elif letter in ('G','H','I'):
            nValor = 4
        elif letter in ('J','K','L'):
            nValor = 5
        elif letter in ('M','N','O'):
            nValor = 6
        elif letter in ('P','Q','R'):
            nValor = 7
        elif letter in ('S','T','U'):
            nValor = 8
        elif letter in ('V','W','X'):
            nValor = 9
        elif letter in ('Y','Z'):
            nValor = 0

        return nValor

    def _get_ref_Banorte(self, mod_empresa, partner_id):
        ref = ''
        cero = '0'
        # sCliente = sCliente.upper()
        sCliente = cero * (20 - len(str(partner_id))) + str(partner_id)
        sEmpresa = cero * (5 - len(str(mod_empresa))) + str(mod_empresa)
        sCadena = sEmpresa + sCliente

        iCount = 1
        nSuma = 0
        nValue = 0
        cValue = ''
        sChar = ''
        while (iCount <= 25):
            nValue = 0
            sChar = sCadena[iCount - 1]
            sChar = sChar.upper()
            if ord(sChar) >= 48 and ord(sChar) <= 57:
                nValue = int(sChar)
            if ord(sChar) >= 65 and ord(sChar) <= 90:
                nValue = _get_Letter_Value_MOD97(sChar)

            if iCount % 2 == 0:
                nValPos = 1
            else:
                nValPos = 2

            nValue = nValue * nValPos
            cValue = str(nValue)
            if len(cValue) > 1:
                nSuma = nSuma + int(cValue[:1]) + int(cValue[-1])
            else:
                nSuma = nSuma + nValue

            iCount = iCount + 1

        nSuma = nSuma % 10
        nSuma = 10 - nSuma
        if nSuma > 9:
            nSuma = 0
        sCadena = sCadena + str(nSuma)
        ref = str(int(sCadena[-21:]))
        return ref

def conv_ascii(text):
    """
    @param text : text that need convert vowels accented & characters to ASCII
    Converts accented vowels, ñ and ç to their ASCII equivalent characters
    """
    old_chars = [
        'á', 'é', 'í', 'ó', 'ú', 'à', 'è', 'ì', 'ò', 'ù', 'ä', 'ë', 'ï', 'ö',
        'ü', 'â', 'ê', 'î', 'ô', 'û', 'Á', 'É', 'Í', 'Ó', 'Ú', 'À', 'È', 'Ì',
        'Ò', 'Ù', 'Ä', 'Ë', 'Ï', 'Ö', 'Ü', 'Â', 'Ê', 'Î', 'Ô', 'Û', 'ñ', 'Ñ',
        'ç', 'Ç', 'ª', 'º', '°', ' ', 'Ã', 'Ø'
    ]
    new_chars = [
        'a', 'e', 'i', 'o', 'u', 'a', 'e', 'i', 'o', 'u', 'a', 'e', 'i', 'o',
        'u', 'a', 'e', 'i', 'o', 'u', 'A', 'E', 'I', 'O', 'U', 'A', 'E', 'I',
        'O', 'U', 'A', 'E', 'I', 'O', 'U', 'A', 'E', 'I', 'O', 'U', 'n', '_',
        'c', 'C', 'a', 'o', 'o', ' ', 'A', '0'
    ]
    for old, new in zip(old_chars, new_chars):
        try:
            text = text.replace(unicode(old, 'UTF-8'), new)
        except:
            try:
                text = text.replace(old, new)
            except:
                raise orm.except_orm(
                    _('Warning !'),
                    _("Can't recode the string [%s] in the letter [%s]") %
                    (text, old)
                )
    return text
