# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (c) 2018 SACSA - http://www.gruposacsa.com.mx
#    All Rights Reserved.
###############################################################################
#    Coded by: Jorge Alfonso Medina Uriarte(desarrollo.sacsa@gruposacsa.com.mx)
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from openerp.addons.account.report import account_print_invoice
from openerp.report import report_sxw
from openerp.tools.translate import _
from num2words import num2words

import logging

_logger = logging.getLogger(__name__)


class Parser(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(Parser, self).__init__(cr, uid, name, context)
        self.context = context
        self.localcontext.update({
            'date_to_text': self._get_date_to_text,
            'amount_total': self._get_amount_total,
            'convert_to_words': self._convert_to_words,
            'date_due': self._get_date_due,
        })

    def _get_date_to_text(self, date):
        MES = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre",
               "Noviembre", "Diciembre"]
        dates = str(date).split('/')
        if len(dates) > 1:
            m = int(dates[1])
            return dates[0] + " de " + str(MES[m - 1]) + " de " + dates[2]
        else:
            dates = str(date).split('-')
            m = int(dates[1])
            return dates[2] + " de " + str(MES[m - 1]) + " de " + dates[0]

    def _get_amount_total(self, amount_total):
        # amount_total = amount_total + amount_total * .10;
        return amount_total

    def _convert_to_words(self, voucher):
        return num2words(self._get_amount_total(voucher.amount), to='currency', lang="es_MX", currency="MXN")

    def _get_date_due(self):
        val = self.pool.get('ir.config_parameter').get_param(self.cr, self.uid, 'pagare.cheque.vencimiento')
        return val
